/* ASCAN.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/*********************************************************************/
/* Function declaration */

#if USE_IBM                 /* Low Level Functions defined in ibmdos.c */
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif

int is_newer();
void scan();
/*********************************************************************/
char redirect_to[FLENGTH];     /* ie >Nul */
char *cfgfile=NULL;            /* configuration file to use */
char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */
char dest_directory[FLENGTH];  /* Work directory */
char scanner[FLENGTH];         /* name of scanner + options */
char unarcer[FLENGTH+50];      /* unarcer + options */

char self_extracts;            /* 0 - off, 1 - on */
int newer_than;
int version=-1;

char look_through[15];

typedef struct file_stack FILES;
struct file_stack {            /* holds a directory listing */
   char string[13];
   FILES *next;
};

struct ffblk ffblk;          /* directory entry structure */
struct ftime ftime_hold;
FILES *head,*tail,*temp_hold,*done_head,*done_tail;
/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"
#include "self.c"
/***********************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120];
   FILE_N file;
   int i,done;

/*********************************************************************/
/* Title */

   my_printf(VERSION);
   my_printf("Archive Scanner\n\n");

   parse_comm_line(argc,argv);
/*****************************************************************/
   if (look_through[0]==NULL)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");


   if (cfgfile==NULL)         /* while we are still on the cur directory */
      file=opencfg("AU.CFG");
   else
      file=opencfg(cfgfile);     /* if -c specified */
/**********************************************************************/
/* parse the .cfg file for the control info */

   while (TRUE) {
      int on_off;
      char string2[50],string3[15];

      get_file_line(file,string);
      if (string[0]==EOF)
         break;

      split_string(string,string3);
      split_string(string,string2);

      on_off=stricmp(string2,"ON")==0;
      if (stricmp(string3,"begin")==0 && stricmp(string2,"ascan")!=0) {
         while (TRUE) {
            get_file_line(file,string);
            if (string[0]==EOF)
               break;
            if (string[0]==NULL)
               continue;
            split_string(string,string3);
            split_string(string,string2);
            if (stricmp(string3,"begin")==0 && stricmp(string2,"ascan")==0)
               break;
         }
      }
      else if (stricmp(string3,"self_extracts")==0)
         self_extracts = on_off;
/*      else if (stricmp(string3,"redirect_to")==0 && redirect_to[0]==NULL) {
         strcpy(redirect_to," >>");
         strcat(redirect_to,string2);
      } */
      else if (stricmp(string3,"version")==0) {
         int i=0;
         version=0;
         while (string2[i]!=NULL) {
            if (string2[i]>='0' && string2[i]<='9')
               version=version*10+(string2[i]-48);
            i++;
         }
      }
      else if (stricmp(string3,"newer_than")==0) {
         int i=0;
         newer_than=0;
         while (string2[i]!=NULL) {
            if (string[2]>='0' && string2[i]<='9')
               newer_than=newer_than*10+(string2[i]-48);
            i++;
         }
      }
      else if (stricmp(string3,"scanner")==0) {
         strcpy(scanner,string2);
         strcat(scanner," ");
         strcat(scanner,string);
      }
      else if (stricmp(string3,"unarcer")==0) {
         strcpy(unarcer,string2);
         strcat(unarcer," ");
         strcat(unarcer,string);
      }
   }
   my_fclose(file);
   parse_comm_line(argc,argv);
/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);     /* hold onto the current directory */

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */
/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0))
      goto end_prog;
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;
/********************************************************************/

   system("md conv89");
   if (dest_directory[0]!=NULL) {
      cd(dest_directory);                    /* make sure it exists */
      getcwd(dest_directory,FLENGTH);
      cd(source_directory);
   }
   else {
      strcpy(dest_directory,source_directory);
      if (dest_directory[strlen(dest_directory)-1]!='\\')
         strcat(dest_directory,"\\");
      strcat(dest_directory,"conv89");
   }
   strcpy(string,"echo ");
   strcat(string,scanner);
   strcat(string," %1 >bscan.bat");
   system(string);
   system("echo IF ERRORLEVEL 1 GOTO BAD >>bscan.bat");
   system("echo GOTO GOOD >>bscan.bat");
   system("echo :BAD >>bscan.bat");
   system("echo RENAME %2 %3 >>bscan.bat");
   system("echo :GOOD >>bscan.bat");
   system("echo EXIT >>bscan.bat");

   while (head!=NULL)  {
      strcpy(string,head->string);   /* Don't short cut these 2 lines */
      scan(string);                  /* no matter what */
      check_for_key();
      temp_hold=head;
      head=head->next;
      free(temp_hold);              /* clean up behind */
   }
   system("rd conv89");

   unlink("bscan.bat");

end_prog:
   {
      int done;
      done = findfirst("*.VIR",&ffblk,0);
      if (done)
         my_printf("All Archive files scanned are OK\n");
      cd(cur_directory);
      exit(!done);  /* errorlevel 1 if a .BAD file exists */
   }
}
/*********************************************************************/
void scan(char string[])
{
   int i=0,done;
   char string2[120],format[5],old_string[120];

   if (strstr(string,".LZH") || strstr(string,".ZIP") ||
       strstr(string,".PAK") || strstr(string,".ARC") ||
       strstr(string,".ZOO") || strstr(string,".DWC") ||
       strstr(string,".LBR") || is_self_extract(string))
          goto around;

   strcpy(format,get_format(string));
   if (format[0]!='*')
      goto around;

   return;
around:
   if (!is_newer(string))
      return;

   strcpy(old_string,string);
   my_printf("Scanning ");
   my_printf(string);
   my_printf("\n");

   strcpy(string2,unarcer);
   strcat(string2," ");
   strcat(string2,string);
   strcat(string2," ");
   strcat(string2,dest_directory);
   strcat(string2,">NUL");
   system(string2);

   strcpy(string2,"bscan ");
   strcat(string2,dest_directory);
   strcat(string2," ");
   strcat(string2,string);

   while (string[i++]!='.');
   string[i-1]=NULL;
   strcat(string,".vir");

   strcat(string2," ");
   strcat(string2,string);
   system(string2);

   cd(dest_directory);
   system("echo Y | del *.* >NUL");                 /* del *.* */
   cd(source_directory);

   if (version!=-1) {
      FILE_N file;

      ftime_hold.ft_tsec=0;
      ftime_hold.ft_hour=version / 60;
      ftime_hold.ft_min=version % 60;
      file=my_fopen(old_string);
      if (file==NULL)                    /* in case it is a .vir */
         file=my_fopen(string);
      setftime(file,&ftime_hold);
      my_fclose(file);
   }

   return;
}
/************************************************************************/
int is_newer(char string[])
{
   FILE_N file;

   file=my_fopen(string);
   getftime(file,&ftime_hold);
   my_fclose(file);

   if (version==-1 || newer_than==0)
      return TRUE;

   if (ftime_hold.ft_tsec==0 && version-newer_than < ftime_hold.ft_hour*60+
          ftime_hold.ft_min)
      return FALSE;
   else
      return TRUE;
}
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */

   int i,option;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)    /* parameter continues on next */
            cur_argv = argv[++i];
         else
            cur_argv+=2;           /* advance it 2 characters */

         if (option=='X')
            self_extracts = (stricmp(cur_argv,"ON")==0);
         else if (option=='N') {
            newer_than=0;
            while (*cur_argv!=NULL) {
               if (*cur_argv>='0' && *cur_argv<='9')
                  newer_than=newer_than*10+(*cur_argv-48);
               cur_argv++;
            }
         }
         else if (option=='V') {
            version=0;
            while (*cur_argv!=NULL) {
               if (*cur_argv>='0' && *cur_argv<='9')
                  version=version*10+(*cur_argv-48);
               cur_argv++;
            }
         }
         else if (option=='W')
            strcpy(dest_directory,cur_argv);
         else if (option=='C')
            cfgfile=cur_argv;
         else if (option=='?') {
            my_printf("Command line parameters:\n-----------------------\n");
            my_printf("-Xon / -Xoff  scan self eXtracts on/off\n");
            my_printf("-Vn           n=Version of scan being used\n");
            my_printf("-N<x> scan only if scanned more than x versions ago\n");
            my_printf("-W work/directory\n");
            my_printf("-C<file>      alternate Configuration file\n");
            exit (0);
         }
         else {
            char string[2];
            my_printf("Invalid Command Line Parameter");
            string[0]=option;
            string[1]=NULL;
            my_printf(string);
            my_printf("\n");
            exit(0);
         }
      }
      else {
         int j,k=0;
         for (j=strlen(cur_argv);j>=0;j--) {
            if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
               while (k<=j) {
                  source_directory[k]=cur_argv[k];
                  k++;
               }
               cur_argv+=k;              /* advance k characters */
               source_directory[k]=NULL;
               break;
            }
         }
         strcpy(look_through,cur_argv);
      }
   }
}

