/* HEADER.C    ver 1.11B
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"      /* Globally used defines */
/*********************************************************************/
/* Define Statements */

#define NO_METHODS 20

     /* Maximum number of archive methods, I doubt this number will need
        changing too soon */
/*********************************************************************/
/* Function declaration */

#if USE_IBM    /* Low Level Functions defined in ibmdos.c */
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif

FILE_N opencfg();
int header(),header_one(),fcount();
/*********************************************************************/
/* -1 is non-commital for these parameters */

char smart=-1;                 /* 0 - off, 1 - on, 2 - always */
char self_extracts=-1;         /* 0 - off, 1 - on */
char date_retain=-1;           /* 0 - off, 1 - on, 2 - last, 3 - first*/

char *cfgfile=NULL;            /* configuration file to use */
char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */

char number=0;                 /* number of comment methods in .CFG file */
char number_header=0;          /* number of redirect files */

char ext[NO_METHODS][5],       /* extensions ie .ZIP, .LZH  */
     *method[NO_METHODS];      /* comment methods ie PKUNZIP, LHARC -x */

char look_through[15];

typedef struct file_stack FILES;
struct file_stack {            /* holds a directory listing */
   char string[13];
   FILES *next;
};
FILES *head,*tail,*temp_hold;

typedef struct header_stack HEADER;
struct header_stack {            /* holds a directory listing */
   char *file_name;
   HEADER *next;
};

HEADER *h_head,*h_tail,*h_temp;
/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"    /* universal functions used in all the programs */
#include "self.c"        /* self extract identify code */
/***********************************************************************/
main(int argc,char *argv[])
{
   char string[120];
   FILE_N file;
   int i,done;
   struct ffblk ffblk;           /* directory entry structure */

/*********************************************************************/
/* Title */

   my_printf(VERSION);
   my_printf("Archive Header Changer\n");
   my_printf("Type HEADER -? for help\n\n");

/********************************************************************/
/* Initialize the random number generator */
   {
      long temp;
      srand(time(&temp) % 37);
   }

   parse_comm_line(argc,argv);

   if (cfgfile==NULL)         /* while we are still on the cur directory */
      file=opencfg("AU.CFG");
   else
      file=opencfg(cfgfile);     /* if -c specified */

/**********************************************************************/
/* parse the .cfg file for the control info */

   while (TRUE) {
      get_file_line(file,string);
      if (string[0]==EOF)
         break;

      if (string[0]=='.') {
         split_string(string,ext[number]);
         method[number]=(char*)malloc(strlen(string)+1);
         strcpy(method[number++],string);
      }
      else {
         char string2[50],string3[15];
         split_string(string,string3);
         split_string(string,string2);

         if (stricmp(string3,"begin")==0 && stricmp(string2,"header")!=0) {
            while (TRUE) {
               get_file_line(file,string);
               if (string[0]==EOF)
                  break;
               if (string[0]==NULL)
                  continue;
               split_string(string,string3);
               split_string(string,string2);
               if (stricmp(string3,"begin")==0 && stricmp(string2,"header")==0)
                  break;
            }
         }
         else if (stricmp(string3,"smart_mode")==0  && smart==-1) {
            if (stricmp(string2,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = (stricmp(string2,"ON")==0);
         }
         else if (stricmp(string3,"date_retain")==0 && date_retain==-1) {
            if (stricmp(string2,"ON")==0)
               date_retain=1;
            else if (stricmp(string2,"LAST")==0)
               date_retain=2;
            else if (stricmp(string2,"FIRST")==0)
               date_retain=3;
            else
               date_retain=0;
         }
         else if (stricmp(string3,"header_file")==0) {
            h_temp=(HEADER*)malloc(sizeof(HEADER));
            h_temp->file_name=(char*)malloc(strlen(string2)+1);
            strcpy(h_temp->file_name,string2);
            if (h_head==NULL)
               h_head=h_tail=h_temp;
            else {
               h_tail->next=h_temp;
               h_tail=h_temp;
            }
            number_header++;
         }
      }
   }
   my_fclose(file);
   parse_comm_line(argc,argv);

   if (number_header==0) {
      my_printf("No header_file specified\n");
      exit(1);
   }
/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */

/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0))      /* No files to process */
      goto end_prog;
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;

/********************************************************************/

   while (head!=NULL)  {
      strcpy(string,head->string);   /* Don't short cut these 2 lines */
      header(string);                 /* no matter what */
      temp_hold=head;
      head=head->next;
      free(temp_hold);              /* clean up behind */
   }
end_prog:
   cd(cur_directory);
}
/*********************************************************************/
int header(char string[])
{
   int i;
   char string2[120];
   struct ffblk ffblk;

   check_for_key();

   if (smart!=ALWAYS) {
      for (i=0;i<number;i++) {
         if (strstr(string,ext[i])!=NULL)
            return header_one(string,i);
      }
   }
   if (smart>=ON) {
      char format[5];
      strcpy(format,get_format(string));
      for (i=0;i<number;i++) {
         if (strstr(format,ext[i])!=NULL)
            return header_one(string,i);
      }
   }
   return FALSE;
}
/**********************************************************************/
int header_one(char string[],int meth_number)
{
   char picked,i;
   char string2[FLENGTH];    /* build the dos commands in the string */
   struct ftime ftime_hold;

   my_printf("Commenting ");
   my_printf(string);
   my_printf("\n");

   picked=rand() % number_header;
   h_temp=h_head;
   for (i=0;i<picked;i++) {    /* skip to the right file */
      h_temp=h_temp->next;
   }

   if (stricmp(ext[meth_number],".PAK")==0) {
      strcpy(string2,"ECHO @");
      strcat(string2,h_temp->file_name);
      strcat(string2," | ");
      strcat(string2,method[meth_number]);
      strcat(string2," ");
      strcat(string2,string);
   }
   else {
      strcpy(string2,method[meth_number]);
      strcat(string2," ");
      strcat(string2,string);
      strcat(string2," <");
      strcat(string2,h_temp->file_name);
   }
   if (date_retain==1) {
      FILE_N handle;

      handle=my_fopen(string);
      getftime(handle,&ftime_hold);
      my_fclose(handle);
   }

   system(string2);

   if (date_retain==1) {
      FILE_N handle;

      handle=my_fopen(string);
      setftime(handle,&ftime_hold);
      my_fclose(handle);
   }
   else if (date_retain==2) {
      strcpy(string2,"redate ");
      strcat(string2,string);
      strcat(string2," >NUL");
      system(string2);
   }
   else if (date_retain==3) {
      strcpy(string2,"redate -l");
      strcat(string2,string);
      strcat(string2," >NUL");
      system(string2);
   }
   return TRUE;
}
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */
   int the_files=FALSE,option,on_off,i;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)    /* parameter continues on next */
            cur_argv = argv[++i];
         else
            cur_argv+=2;           /* advance it 2 characters */

         on_off = stricmp(cur_argv,"ON")==0;
         if (option=='S') {        /* Smart mode on/off/always */
            if (stricmp(cur_argv,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = on_off;
         }
         else if (option=='C')
            cfgfile=cur_argv;
         else if (option=='D') {
            if (stricmp(cur_argv,"OFF")==0)
               date_retain=0;
            else if (stricmp(cur_argv,"ON")==0)
               date_retain=1;
            else if (stricmp(cur_argv,"LAST")==0)
               date_retain=2;
            else if (stricmp(cur_argv,"FIRST")==0)
               date_retain=3;
         }
         else if (option=='?') {
            my_printf("Command line parameters:\n-----------------------\n");
            my_printf("-Son / -Soff / -Salways  Smart_mode on/off/always\n");
            my_printf("-Don / -Doff / -Dlast /-Dfirst   Date_retain on/off/last/first\n");
            my_printf("-c<file>      alternate Configuration file\n");
            exit (0);
         }
         else {
            char string[2];
            my_printf("Invalid Command Line Parameter ");
            string[0]=option;
            string[1]=NULL;
            my_printf(string);
            exit(0);
         }
      }
      else {
         if (!the_files) {    /* specifying the file(s) to comment */
            int j,k=0;

            for (j=strlen(cur_argv);j>=0;j--) {
               if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
                  while (k<=j) {
                     source_directory[k]=cur_argv[k];
                     k++;
                  }
                  cur_argv+=k;              /* advance k characters */
                  source_directory[k]=NULL;
                  break;
               }
            }
            the_files=TRUE;
            strcpy(look_through,cur_argv);
         }
      }
   }
   if (look_through[0]==NULL || !the_files)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");
}

