/* Low Level IBM routines to make executable smaller */
/********************************************************************/
char my_getch();
FILE_N my_fopen();
int my_getc();
void my_printf(),my_fclose(),my_fseek();
/*******************************************************************/
void my_printf(char string[])             /* low level printf */
{

   union REGS regs;
   int i=0;

   regs.h.ah=2;
   while (string[i]!=NULL) {
      if (string[i]==10) {
         regs.h.dl=13;
         intdos(&regs,&regs);
      }
      regs.h.dl=string[i++];
      intdos(&regs,&regs);
   }
   return;
}
/******************************************************************/
char my_getch()                      /* Low level getch() */
{
   union REGS regs;
   regs.h.ah=0x08;
   intdos(&regs,&regs);
   return regs.h.al;
}
/******************************************************************/
int my_fopen(char file[])              /* Replace C's fopen */
{                                      /* Open for Read only */
   union REGS regs;

   buffer_pointer=0;
   regs.h.ah=0x3d;
   regs.x.dx=(int)file;
   regs.h.al=0;                     /* Read only */
   intdos(&regs,&regs);
   if (regs.x.cflag) {
      if (regs.x.ax==2)             /* File not found */
         return NULL;
      else if (regs.x.ax==3) {
         my_printf("Illegal Path\n");
         return NULL;
      }
      else {
         char string[2];

         my_printf("Dos File Error ");
         string[0]=regs.x.ax+48;
         string[1]=NULL;
         my_printf(string);
         my_printf("\n");
      }
      exit(0);
   }
   return regs.x.ax;          /* Return the handle number */
}
/************************************************************************/
void my_fclose(FILE_N handle)
{
   union REGS regs;
   regs.h.ah=0x3e;
   regs.x.bx=handle;
   intdos(&regs,&regs);
}
/************************************************************************/
int my_getc(FILE_N handle)
{
   union REGS regs;

   if (buffer_pointer<1 || buffer[buffer_pointer]==NULL) {
      buffer_pointer=0;
      regs.x.bx=handle;
      regs.x.cx=128;
      regs.x.dx=(int)&buffer;
      regs.h.ah=0x3f;
      intdos(&regs,&regs);
      if (regs.x.ax==0 || regs.x.cflag)
         return EOF;
      buffer[regs.x.ax]=NULL;
   }
   return buffer[buffer_pointer++];
}
/************************************************************************/
void my_fseek(FILE_N handle,int offset,char method)
{
   union REGS regs;

   regs.x.bx=handle;
   regs.h.al=method;
   if (offset<0)
      regs.x.cx=65535;
   else
      regs.x.cx=0;
   regs.x.dx=offset;
   regs.h.ah=0x42;
   intdos(&regs,&regs);
   buffer_pointer=0;
}

