/* REDATE.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/*********************************************************************/
#if USE_IBM
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif
/*********************************************************************/
/* Function declaration */

int get_month();
void rebuild_date(),set_max(),init_date(),scan(),redate(),
     redate_lzh(),redate_pak(),redate_zip(),redate_zoo(),redate_dwc();
/*********************************************************************/

/* -1 is non-commital for these parameters */

char smart=1;                  /* 0 - off, 1 - on, 2 - always */
char self_extracts=-1;         /* 0 - off, 1 - on */

char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */
char dest_directory[FLENGTH];  /* Work Directory */
char use_maximum=TRUE;         /* max or min date */

int i,c,d,e,year,month,day,max_year,max_month,max_day;

typedef struct file_stack FILES;
struct file_stack {            /* holds a directory listing */
   char string[13];
   FILES *next;
};

FILES *head,*tail,*temp_hold;

struct ffblk ffblk;          /* directory entry structure */
/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          FALSE    /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      FALSE
#define USE_GET_FILE_LINE    FALSE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     FALSE
#include "universe.c"
#include "self.c"
/***********************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120],look_through[15];
   FILE_N file;
   int done;
   struct ffblk ffblk;          /* directory entry structure */

/*********************************************************************/
/* Title */

   my_printf(VERSION);
   my_printf("File Redater\n\n");

/*********************************************************************/
/* Parse the command line parameters */

   {
      int the_files=FALSE,option;
      char *cur_argv;

      for (i=1;i<argc;i++) {
         cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
         strupr(cur_argv);
         if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
            option=cur_argv[1];
            if (option=='L') {
               use_maximum=FALSE;
               continue;
            }
            else if (option=='H') {
               use_maximum=TRUE;
               continue;
            }
            if (cur_argv[2]==NULL)    /* parameter continues on next */
               cur_argv = argv[++i];
            else
               cur_argv+=2;           /* advance it 2 characters */
            if (option=='S') {        /* Smart mode on/off/always */
               if (stricmp(cur_argv,"ALWAYS")==0)
                  smart=ALWAYS;
               else
                  smart = (stricmp(cur_argv,"ON")==0);
            }
            else if (option=='X')
               self_extracts = stricmp(cur_argv,"ON")==0;
            else if (option=='W') {
               strcpy(dest_directory,cur_argv);
            }
            else if (option=='?') {
               my_printf("Command line parameters:\n-----------------------\n");
               my_printf("-son / -soff / -salways  Smart_mode on/off/always\n");
               my_printf("-xon / -xoff  self eXtracts on/off\n");
               my_printf("-w work/directory\n");
               my_printf("-l look for lowest (oldest) date\n");
               my_printf("-h look for highest (newest) date\n");
               exit (0);
            }
            else {
               my_printf("Invalid Command Line Parameter");
               string[0]=option;
               string[1]=NULL;
               my_printf(string);
               exit(0);
            }
         }
         else {                  
            if (!the_files) {    /* specifying the file(s) to unarc */
               int j,k=0;

               for (j=strlen(cur_argv);j>=0;j--) {
                  if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
                     while (k<=j) {
                        source_directory[k]=cur_argv[k];
                        k++;
                     }
                     cur_argv+=k;              /* advance k characters */
                     source_directory[k]=NULL;
                     break;
                  }
               }
               the_files=TRUE;
               strcpy(look_through,cur_argv);
            }
         }
      }
/*****************************************************************/
      if (look_through[0]==NULL || !the_files)
         strcpy(look_through,"*.*");

      if (!strstr(look_through,"."))
         strcat(look_through,".*");
   }

/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */

   cd(dest_directory);
   getcwd(dest_directory,FLENGTH);
   if (dest_directory[strlen(dest_directory)-1]!='\\')
      strcat(dest_directory,"\\");
   strcat(dest_directory,"temp89.dat");

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */

/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0))
      goto end_prog;
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;
/********************************************************************/

   while (head!=NULL)  {
      strcpy(string,head->string);
      redate(string);
      check_for_key();
      temp_hold=head;
      head=head->next;
      free(temp_hold);              /* clean up behind */
   }
/**********************************************************************/
end_prog:
   unlink(dest_directory);
   cd(cur_directory);
}

/*********************************************************************/
void redate(char string[])
{
   init_date();

   if ((strstr(string,".COM")!=NULL || strstr(string,".EXE")!=NULL)
      && is_self_extract(string)) {

      char string2[FLENGTH];
      long fsize;

      system("md conv89");
      strcpy(string2,"COPY ");
      strcat(string2,string);
      strcat(string2," conv89 >NUL");
      system(string2);
      system("cd conv89");
      {
         int j=0;
         while (TRUE) {
            if (string[j]=='.') {
               string[j]=NULL;
               break;
            }
            j++;
         }

         strcpy(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");
         strcat(string2,string);
         strcat(string2,">NUL");
         string[j]='.';                     /* reinstate the .com/.exe */
         findfirst(string,&ffblk,0);
         fsize=ffblk.ff_fsize;
         system(string2);

         findfirst(string,&ffblk,0);
         if (fsize==ffblk.ff_fsize)        /* if the .com file doesn't contain */
            unlink(string);                /* a file with the same exact name */
      }
      {
         struct ftime ftime_hold;
         int handle,done;

         done=findfirst("*.*",&ffblk,0);
         while (!done) {
            strcpy(string2,ffblk.ff_name);
            handle=open(string2,1);
            getftime(handle,&ftime_hold);
            close(handle);
            year=ftime_hold.ft_year+80;
            month=ftime_hold.ft_month;
            day=ftime_hold.ft_day;
            set_max();
            done=findnext(&ffblk);
         }
         system("echo Y | del *.* >NUL");
      }
      system("cd ..");
      system("rd conv89");
      rebuild_date(max_year,max_month,max_day,string);
      return;
   }
   if (smart!=ALWAYS) {
      if (strstr(string,".LZH")!=NULL) {
         redate_lzh(string);
         return;
      }
      else if (strstr(string,".ZIP")!=NULL) {
         redate_zip(string);
         return;
      }
      else if (strstr(string,".PAK")!=NULL) {
         redate_pak(string);
         return;
      }
      else if (strstr(string,".ZOO")!=NULL) {
         redate_zoo(string);
         return;
      }
      else if (strstr(string,".ARC")!=NULL) {
         redate_pak(string);
         return;
      }
      else if (strstr(string,".DWC")!=NULL) {
         redate_dwc(string);
         return;
      }
   }
   if (smart>0) {
      char format[5];
      strcpy(format,get_format(string));
      if (strstr(format,".LZH")!=NULL) {
         redate_lzh(string);
         return;
      }
      else if (strstr(format,".ZIP")!=NULL) {
         redate_zip(string);
         return;
      }
      else if (strstr(format,".PAK")!=NULL) {
         redate_pak(string);
         return;
      }
      else if (strstr(format,".ZOO")!=NULL) {
         redate_zoo(string);
         return;
      }
      else if (strstr(format,".ARC")!=NULL) {
         redate_pak(string);
         return;
      }
      else if (strstr(format,".DWC")!=NULL) {
         redate_dwc(string);
         return;
      }
   }
   return;
}
/******************************************************************/
void redate_lzh(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;

   strcpy(string2,"LHARC v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,dest_directory);
   system(string2);

   file=my_fopen(dest_directory);
   my_fseek(file,100,0);
   scan(file,"---- ----- ----");

   while (1) {
      for(i=0;i<13;i++)                     /* skip over file name. */
         c=my_getc(file);
      if (c==EOF || c=='-')
         break;
      while (my_getc(file)!='%');          /* go to the % */
      my_getc(file);                       /* one more space */
      c=my_getc(file); d=my_getc(file);
      year=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      month=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      day=(c-48)*10+(d-48);
      set_max();
      while (1) {
        c=my_getc(file);
        if (c=='\n' || c==EOF)
           break;
      }
   }
   my_fclose(file);
   rebuild_date(max_year,max_month,max_day,string);

   return;
}
/******************************************************************/
void redate_pak(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;

   strcpy(string2,"PAK v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,dest_directory);
   system(string2);

   file=my_fopen(dest_directory);
   my_fseek(file,200,0);

   scan(file,"====  ========  ====");
   while (1) {
      c=my_getc(file);
      if (c==EOF || c==' ')
         break;
      for(i=0;i<23;i++)                     /* skip over file name. */
         c=my_getc(file);

      c=my_getc(file); d=my_getc(file);
      month=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      day=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      year=(c-48)*10+(d-48);
      set_max();
      while (1) {
        c=my_getc(file);
        if (c=='\n' || c==EOF)
           break;
      }
   }
   my_fclose(file);
   rebuild_date(max_year,max_month,max_day,string);

   return;
}
/******************************************************************/
void redate_zip(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;

   strcpy(string2,"PKUNZIP -v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,dest_directory);
   system(string2);

   file=my_fopen(dest_directory);
   my_fseek(file,210,0);
   scan(file,"----- -----   ----");

   while (1) {
      c=my_getc(file);
      c=my_getc(file);
      if (c==EOF || c=='-')
         break;
      for(i=0;i<28;i++)                     /* skip over file name. */
         c=my_getc(file);

      while ((c=my_getc(file))==' '); /* so that is will work with .92 and 1.0 */
      d=my_getc(file);

      month=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      day=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      year=(c-48)*10+(d-48);
      set_max();
      while (1) {
        c=my_getc(file);
        if (c=='\n' || c==EOF)
           break;
      }
   }
   my_fclose(file);
   rebuild_date(max_year,max_month,max_day,string);

   return;
}
/******************************************************************/
void redate_dwc(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;

   strcpy(string2,"DWC v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,dest_directory);
   system(string2);

   file=my_fopen(dest_directory);
   my_fseek(file,100,0);
   scan(file,"=========  ======  ====");

   while (1) {
      c=my_getc(file);
      if (c==EOF || c==' ')
         break;
      for(i=0;i<49;i++)                     /* skip over file name. */
         c=my_getc(file);

      c=my_getc(file); d=my_getc(file);
      day=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file); e=my_getc(file);
      month=get_month(c,d,e);

      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      year=(c-48)*10+(d-48);
      set_max();
      while (1) {
        c=my_getc(file);
        if (c=='\n' || c==EOF)
           break;
      }
   }
   my_fclose(file);
   rebuild_date(max_year,max_month,max_day,string);

   return;
}
/******************************************************************/
void redate_zoo(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;

   strcpy(string2,"ZOO -list ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,dest_directory);
   system(string2);

   file=my_fopen(dest_directory);
   scan(file,"--- --------  ---------");

   while (1) {
      c=my_getc(file);
      if (c==EOF || c=='-')
         break;
      for(i=0;i<23;i++)                     /* skip over file name. */
         c=my_getc(file);

      c=my_getc(file); d=my_getc(file);
      day=(c-48)*10+(d-48);
      my_getc(file);
      c=my_getc(file); d=my_getc(file); e=my_getc(file);
      month=get_month(c,d,e);

      my_getc(file);
      c=my_getc(file); d=my_getc(file);
      year=(c-48)*10+(d-48);
      set_max();
      while (1) {
        c=my_getc(file);
        if (c=='\n' || c==EOF)
           break;
      }
   }
   my_fclose(file);
   rebuild_date(max_year,max_month,max_day,string);

   return;
}
/*******************************************************************/
void rebuild_date(int year,int month,int day,char string[])
{
   struct ftime ftime_hold;
   FILE_N file;

   file=my_fopen(string);
   getftime(file,&ftime_hold);  /* so we can keep the time the same */
   ftime_hold.ft_day=day;
   ftime_hold.ft_month=month;
   ftime_hold.ft_year=year-80;
   setftime(file,&ftime_hold);
   my_fclose(file);
}
/************************************************************************/
void set_max()
{
   if (use_maximum) {
      if (year>max_year || (year==max_year && month>max_month)
              || (year==max_year && month==max_month && day>max_day)) {
         max_year=year;
         max_month=month;
         max_day=day;
      }
   }
   else {
      if (year<max_year || (year==max_year && month<max_month)
              || (year==max_year && month==max_month && day<max_day)) {
         max_year=year;
         max_month=month;
         max_day=day;
      }
   }

}
/************************************************************************/
void init_date()
{
   if (use_maximum)
      max_year=max_month=max_day=0;
   else
      max_year=max_month=max_day=999;
}
/************************************************************************/
void scan(FILE_N file,char string[])
{
   char string2[120];
   int i,c;

   while (1) {
      i=0;
      while ((c=my_getc(file))!='\n') {
         string2[i++]=c;
         if (c==EOF)
            exit(2);
      }

      string2[i]=NULL;
      if (strstr(string2,string))
         return;
   }
}
/************************************************************************/
int get_month(char c, char d, char e)
{
   if (c=='J' && d=='a')
      return 1;
   else if (c=='F')
      return 2;
   else if (c=='M' && d=='a' && e=='r')
      return 3;
   else if (c=='A' && d=='p')
      return 4;
   else if (c=='M')
      return 5;
   else if (c=='J' && d=='u' && e=='n')
      return 6;
   else if (c=='J')
      return 7;
   else if (c=='A')
      return 8;
   else if (c=='S')
      return 9;
   else if (c=='O')
      return 10;
   else if (c=='N')
      return 11;
   else
      return 12;
}
