/* TEST.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/*********************************************************************/
/* Define Statements */

#define NO_METHODS 20

     /* Maximum number of testing methods, I doubt this number will need
        changing too soon */

/*********************************************************************/
#if USE_IBM
   typedef int FILE_N;      /* Corresponding to a handle */
   void my_fputs();
#else
   typedef FILE* FILE_N;
   #define my_fputs(x,y) fputs(x,y)
#endif
/*********************************************************************/
/* Function declaration */

FILE_N opencfg();
void test(),test_one();
/*********************************************************************/
char smart;                    /* 0 - off, 1 - on, 2 - always */

char redirect_to[FLENGTH];     /* ie >Nul */
char cfgfile[FLENGTH];         /* configuration file to use */
char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */

int number=0;             /* number of testc methods specified in .CFG file */

char ext[NO_METHODS][5],       /* extensions ie .ZIP, .LZH  */
     *method[NO_METHODS];      /* test methods ie PKUNZIP, LHARC -x */

char look_through[15];

typedef struct file_stack FILES;
struct file_stack {              /* holds a directory listing */
   char string[13];              /* file name */
   FILES *next;                  /* next in the queue */
};

FILES *head,*tail,*temp_hold;
/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"    /* universal functions used in all the programs */
/***********************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120];
   FILE_N file;
   int i;
   struct ffblk ffblk;          /* directory entry structure */

/*********************************************************************/
/* Title */

   my_printf(VERSION);
   my_printf("Archive Tester\n");
   my_printf("Type TEST -? for help\n\n");

   parse_comm_line(argc,argv);

   if (cfgfile[0]==NULL)          /* while we are still on the cur directory */
      file=opencfg("AU.cfg");
   else
      file=opencfg(cfgfile);      /* if -c is used */

/**********************************************************************/
/* parse the .cfg file for the control info */

   while (TRUE) {
      get_file_line(file,string);
      if (string[0]==EOF)
         break;
      if (string[0]=='.') {
         split_string(string,ext[number]);
         method[number]=(char*)malloc(strlen(string)+1);
         strcpy(method[number],string);
         number++;
      }
      else {
         char string2[50],string3[15];
         split_string(string,string3);
         split_string(string,string2);
         if (stricmp(string3,"begin")==0 && stricmp(string2,"test")!=0) {
            while (TRUE) {
               get_file_line(file,string);
               if (string[0]==EOF)
                  break;
               if (string[0]==NULL)
                  continue;
               split_string(string,string3);
               split_string(string,string2);
               if (stricmp(string3,"begin")==0 && stricmp(string2,"test")==0)
                  break;
            }
         }
         else if (stricmp(string3,"smart_mode")==0) {
            if (stricmp(string2,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart=(stricmp(string2,"ON")==0);
         }
         else if (stricmp(string3,"redirect_to")==0 && redirect_to[0]==NULL) {
            strcpy(redirect_to," >>");
            strcat(redirect_to,string2);
         }
      }
   }
   parse_comm_line(argc,argv);

/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */
/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0))
      goto end_prog;
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;

/********************************************************************/

   /* Create test89.bat */
   {
      FILE_N batfile;
      union REGS regs;

#if USE_IBM
      regs.h.ah=0x3c;
      regs.x.dx=(int)"test89.bat";
      regs.x.cx=0;
      intdos(&regs,&regs);
      batfile=regs.x.ax;
#else
      batfile=fopen("test89.bat","w");
#endif
      my_fputs("%3 %4 %5 %6 %7 %8 %9",batfile);
      my_fputs(redirect_to,batfile);
      my_fputs("\r\nIF ERRORLEVEL 1 GOTO BAD\r\nGOTO GOOD\r\n:BAD\r\nRENAME %1 %2\r\n:GOOD\r\nEXIT\r\n",batfile);
      my_fclose(batfile);
   }
   while (head!=NULL)  {
      strcpy(string,head->string);  /* Don't short cut these 2 lines */
      test(string);                 /* no matter what */
      check_for_key();
      temp_hold=head;
      head=head->next;
      free(temp_hold);              /* clean up behind */
   }
/**********************************************************************/
end_prog:

   unlink("test89.bat");
   {
      int done;
      done = findfirst("*.BAD",&ffblk,0);
      if (done)
         my_printf("All Archive files tested are OK\n");
      cd(cur_directory);
      exit(!done);  /* errorlevel 1 if a .BAD file exists */
   }
}
/*********************************************************************/
void test(char string[])
{
   int i;

   if (smart!=ALWAYS) {
      for (i=0;i<number;i++) {
         if (strstr(string,ext[i])!=NULL) {
            test_one(string,i);
            return;
         }
      }
   }
   if (smart>=ON) {
      char format[5];
      strcpy(format,get_format(string));
      for (i=0;i<number;i++) {
         if (strstr(format,ext[i])!=NULL) {
            test_one(string,i);
            return;
         }
      }
   }
   return;
}
/**********************************************************************/
void test_one(char string[],int meth_number)
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   int before,after;

   my_printf("Testing ");
   my_printf(string);
   my_printf("\n");
   strcpy(string2,"test89 ");
   strcat(string2,string);
   strcat(string2," ");
   {
      char string3[13];
      int i=0;

      while (string[i]!='.')
         string3[i]=string[i++];
      string3[i]=NULL;
      strcat(string2,string3);
      strcat(string2,".BAD ");
   }
   strcat(string2,method[meth_number]);
   strcat(string2," ");
   strcat(string2,string);
   strcat(string2,redirect_to);
   system(string2);
   return;
}
/***********************************************************************/
#if USE_IBM
void my_fputs(char string[], FILE_N handle)
{
   union REGS regs;

   regs.h.ah=0x40;
   regs.x.bx=handle;
   regs.x.cx=strlen(string);
   regs.x.dx=(int)string;
   intdos(&regs,&regs);
}
#endif
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */

   int the_files=FALSE,option,i;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)    /* parameter continues on next */
            cur_argv = argv[++i];
         else
            cur_argv+=2;           /* advance it 2 characters */
         if (option=='S') {
            if (stricmp(cur_argv,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart=(stricmp(cur_argv,"ON")==0);
         }
         else if (option=='O') {
            strcpy(redirect_to," >>");
            strcat(redirect_to,cur_argv);
         }
         else if (option=='C')
            strcpy(cfgfile,cur_argv);
         else if (option=='?') {
            my_printf("Command line parameters:\n-----------------------\n");
            my_printf("-son / -soff / -salways  Smart_mode on/off/always\n");
            my_printf("-c<file>      Alternate Configuration file\n");
            my_printf("-o<file>      Redirect_to\n");
            exit (0);
         }
         else {
            char string[2];
            my_printf("Invalid Command Line Parameter");
            string[0]=option;
            string[1]=NULL;
            my_printf(string);
            exit(0);
         }
      }
      else {
         int j,k=0;

         for (j=strlen(cur_argv);j>=0;j--) {
            if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
               while (k<=j) {
                  source_directory[k]=cur_argv[k];
                  cur_argv[k]=32;
                  k++;
               }
               ltrim(cur_argv);
               source_directory[k]=NULL;
               break;
            }
         }
         the_files=TRUE;
         strcpy(look_through,cur_argv);
      }
   }
   if (look_through[0]==NULL || !the_files)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");
}

