#include <errno.h>

/*******************************************************************/
#if USE_CD
void cd(char string[])     /* supplements the lacking turboc Cs */
{
   char string2[FLENGTH],string3[3];

   if (string[0]==NULL)   /* Don't remove this, 10 lines down will cause you grief */
      return;

   strcpy(string2,string);

   /* strip the trialing \ if it exists */
   if (strlen(string2) > 1 && string2[strlen(string2)-1]=='\\' &&
         string2[strlen(string2)-2]!=':') {
      string2[strlen(string2)-1]=NULL;
   }
   if (string2[1]==':') {
      string3[0]=string2[0];
      string3[1]=':';
      string3[2]=NULL;
      system(string3);
      if (errno==EXDEV)           /* EXDEV = bad drive */
         exit(1);

      string2[0]=string2[1]=32;  /* pick off the first 2 spaces */
      ltrim(string2);
   }
   if (string2[0]!=NULL) {
      if (chdir(string2) == -1) {
         my_printf("Invalid directory - ");
         my_printf(string2);
         exit(1);
      }
   }
}
#endif
/**************************************************************************/
/* open the configuration file, look through path if necessary */

#if USE_OPENCFG
FILE_N opencfg(char filename[])
{
   FILE_N file;

   file=my_fopen(filename);
   if (file==NULL) {                      /* ok, its not in the current */
      int pathpos=0,dirpos;               /* directory so lets trudge through */
      char *path,aupath[200],directory[80];      /* the PATH */

      if (strstr(filename,"\\"))
         goto file_not_found;

      if (getenv("AUPATH")!=NULL) {       /* but first, lets try for aupath */
         strcpy(aupath,getenv("AUPATH"));
         if (aupath[strlen(aupath)-1]!='\\')
            strcat(aupath,"\\");
         strcat(aupath,filename);
         file=my_fopen(aupath);
         if (file!=NULL)
            return file;
      }

      path=getenv("PATH");
      if (path==NULL)
         goto file_not_found;

      while (TRUE) {
         if (path[pathpos]==NULL) {        /* we have looked through the whole
                                              PATH without success */
file_not_found:
            my_printf("Can't find ");
            my_printf(filename);
            exit(1);
         }
         dirpos=0;
         while (path[pathpos]!=';' && path[pathpos]!=NULL) {
            directory[dirpos++]=path[pathpos++];
         }
         pathpos++;     /* get us over the ; */

         if (directory[dirpos-1]!='\\')
            directory[dirpos++]='\\';
         directory[dirpos]=NULL;
         strcat(directory,filename);
         file=my_fopen(directory);
         if (file!=NULL)
            break;
      }
   }
   return file;
}
#endif
/**********************************************************************/
/* determine type of format and return the standard extension         */
#if USE_GET_FORMAT
char *get_format(char *filename)
{

   register char c,d,e;
   int i;
   FILE_N file;
   long pos;

   file=my_fopen(filename);

   c=my_getc(file);
   d=my_getc(file);
   e=my_getc(file);

   if (c=='P' && d=='K' && e==3) {
      my_fclose(file);
      return ".ZIP";
   }
   if (c=='Z' && d=='O' && e=='O') {
      my_fclose(file);
      return ".ZOO";
   }
   d=my_getc(file); e=my_getc(file);
   if (d=='l' && e=='h') {
      my_fclose(file);
      return ".LZH";
   }
   if (d=='l' && e=='z') {
      my_fclose(file);
      return ".LZS";
   }
   if (c==26) {
      my_fseek(file,-2,2);                /* 2 from the end */
      i=0;
      while ((c=my_getc(file))==NULL) {   /* for Xmodem transfers */
         my_fseek(file,-2-i,2);           /* Buffer affects this */
         i++;
      }
      if (c==26) {
         my_fclose(file);
         return ".ARC";
      }
      else {                      /* if (c==-2 && my_getc(file)==0) { */
         my_fclose(file);
         return ".PAK";
      }
   }
/*                                 Doesn't seem to work
   my_fseek(file,19,0);
   c=my_getc(file);
   d=my_getc(file);
   e=my_getc(file);
   f=my_getc(file);
   if (c=='8' && d==16 && e=='8' && f==16) {
      my_fclose(file);
      return ".LBR";
   }
*/
   my_fseek(file,-3,2);               /* 3 back from the end of file */
   i=0;
   while ((c=my_getc(file))==NULL) {   /* for Xmodem transfers */
      my_fseek(file,-3-i,2);           /* Buffer affects this */
      i++;
   }
   d=my_getc(file);
   e=my_getc(file);

   my_fclose(file);                /* No need anymore */
   if (c=='D' && d=='W' && e=='C') {
      char string2[13];
      char string3[50];
      int i=0;

      strcpy(string2,filename);
      while (filename[i++]!='.');
      filename[i++]='D';
      filename[i++]='W';
      filename[i++]='C';
      filename[i]=NULL;
      strcpy(string3,"rename ");
      strcat(string3,string2);
      strcat(string3," ");
      strcat(string3,filename);      /* modifying string itself */
      system(string3);
      return ".DWC";
   }
   return "*.*";                   /* Character a file can't contain */
}
#endif
/*********************************************************************/
#if USE_END_OF_LINE
void end_of_line(FILE_N file)
{
   register int c;

   while ((c=my_getc(file))!=EOF) {
      if (c=='\n')
         return;
   }
}
#endif
/*********************************************************************/
#if USE_GET_FILE_LINE
void get_file_line(FILE_N file,char string[]) /* get a line of text from a file */
                                              /* trim the spaces on both sides */
                                              /* and remove comments */
{

   register int c,string_pos=0;

   while ((c=my_getc(file))!=EOF) {
      if (c==';') {
         end_of_line(file);
         break;
      }
      if (c=='\n' || c==13)
         break;
      string[string_pos++]=c;
   }
   if (string_pos==0 && c==EOF)
      string[string_pos++]=EOF;

   string[string_pos]=NULL;
   c=string_pos-1;                /* take the rtrim right here */
   while (c>=0) {
      if (string[c]!=32)
         break;
      else
         string[c--]=NULL;
   }
   ltrim(string);
}
#endif
/************************************************************************/
#if USE_LTRIM
void ltrim(char string[])  /* chop of leading spaces from string */
{
   register int start=0,pos=0;

   while (string[start++]==32 || string[start]==9);
   start--;
   while ((string[pos++]=string[start++])!=NULL);
}
#endif
/*************************************************************************/
#if USE_CHECK_FOR_KEY
void check_for_key()
{
   char opt;

   if (kbhit()) {
      my_getch();
      my_printf("Continue Y/N:");
      opt=my_getch();
      my_printf("\n");
      if (opt=='N' || opt=='n')
         exit(0);
   }
}
#endif
/***********************************************************************/
#if USE_SPLIT_STRING
void split_string(char string1[], char string2[])
{
   int i=0;

   while (TRUE) {
      if (string1[i]<=' ') {              /* should get space,tab and NULL */
         ltrim(string1);
         string2[i]=NULL;
         return;
      }
      string2[i]=string1[i];
      string1[i]=' ';
      i++;
   }
}
#endif

