/* VIEW.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/**************************************************************/
/* Define Statements */

#define READ 2             
#define WRITE 1

     /* Declarations for BIOSCOM function */

#define BELL 7             

     /* chr(7) is the bell sound on most machines */

#define OPUS 1
#define RBBS 2

     /* BBS systems defined */

/*********************************************************************/
#if USE_IBM    /* Low Level Functions defined in ibmdos.c */
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif

char unarc(),get_com_char(),is_self_extract();
FILE_N opencfg();
int read_char(),fcount();
void put_com_char(),init_fossil(),check_carrier(),parse_ctl(),get_string(),
     view(),list_files(),write_char(),rbbs_search(),dump();

/**************************************************************/
char smart;               /* 1 is on, 2 is always */
char self_extracts;       /* 0 - off, 1 - on */
int  com_port=-2;         /* Com port */
char baud_rate[6];        /* baud rate */
char cfgfile[FLENGTH];    /* configuration file to use */
char ctl_file[FLENGTH];   /* .CTL file that opus uses */
char bbs;                 /* 0 = None, 1 = OPUS */
char avoid[50];
char use_fossil;          /* use fossil yes/no */
char downloads;           /* Downloads yes/no */
char enforce_empty=0;     /* enforce empty work directory Yes/No */
char cur_directory[FLENGTH];
char dest_directory[FLENGTH];
char ext_lister[FLENGTH];

char look_through[15];    /* Files to look through */

char carrier=TRUE;
char string2[120];          /* Used as temporary everywhere*/

struct download_path {
       char *dir;
       struct download_path *next;
};

struct download_path  *dpath_head=NULL,*dpath_tail=NULL,*temp_path;

struct ffblk ffblk;
/***********************************************************************/
#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       FALSE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"    /* universal functions used in all the programs */
#include "self.c"
/****************************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120];

   FILE_N file;
   int i,j;

   parse_comm_line(argc,argv);

   if (look_through[0]==NULL)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");

   if (cfgfile[0]==NULL)
      file=opencfg("AU.cfg");
   else
      file=opencfg(cfgfile);
/**********************************************************************/
/* parse the configuration file for the control info */

   while (TRUE) {
      char string2[FLENGTH],string3[25];
      get_file_line(file,string);
      if (string[0]==EOF)
         break;
      if (string[0]==NULL)
         continue;

      split_string(string,string3);
      split_string(string,string2);
      if (stricmp(string3,"begin")==0 && stricmp(string2,"view")!=0) {
         while (TRUE) {
            get_file_line(file,string);
            if (string[0]==EOF)
               break;
            if (string[0]==NULL)
               continue;
            split_string(string,string3);
            split_string(string,string2);
            if (stricmp(string3,"begin")==0 && stricmp(string2,"view")==0)
               break;
         }
      }
      else if (stricmp(string3,"smart_mode")==0) {
         if (stricmp(string2,"ON")==0)
            smart=1;
         else if (stricmp(string2,"ALWAYS")==0)
            smart=2;
         else
            smart=0;
      }
      else if (stricmp(string3,"self_extracts")==0)
         self_extracts= stricmp(string2,"ON")==0;
      else if (stricmp(string3,"work_directory")==0)
         strcpy(dest_directory,string2);
      else if (stricmp(string3,"avoid_listing")==0)
         strcat(avoid,string2);
      else if (stricmp(string3,"external_lister")==0)
         strcpy(ext_lister,string2);
      else if (stricmp(string3,"com_port")==0 && com_port==-2)
         com_port=string2[0]-49;
      else if (stricmp(string3,"bbs")==0) {
         if (stricmp(string2,"opus")==0)
            bbs=1;
         else if (stricmp(string2,"rbbs")==0)
            bbs=2;
      }
      else if (stricmp(string3,"use_fossil")==0 && strnicmp(string2,"Y",1)==0)
         use_fossil=TRUE;
      else if (stricmp(string3,"downloads")==0 && strnicmp(string2,"Y",1)==0)
         downloads=TRUE;
      else if (stricmp(string3,"enforce_empty_work")==0 && strnicmp(string2,"Y",1)==0)
         enforce_empty=TRUE;
      else if (stricmp(string3,"ctl_file")==0)
         strcpy(ctl_file,string2);
      else if (stricmp(string3,"download_path")==0) {
         temp_path=(struct download_path*)malloc(sizeof(struct download_path));
         if (dpath_head==NULL) {
            dpath_head=temp_path;
            dpath_tail=temp_path;
         }
         else {
            dpath_tail->next=temp_path;
            dpath_tail=temp_path;
         }
         dpath_tail->dir=(char*)malloc(strlen(string2));
         strcpy(dpath_tail->dir,string2);
         dpath_tail->next=NULL;
      }
   }
   parse_comm_line(argc,argv);

   strupr(avoid);
   strcat(avoid,".");

   if (getenv("AULOCAL")!=NULL)
      if (stricmp("ON",getenv("AULOCAL"))==0)
         com_port=-2;

   getcwd(cur_directory,FLENGTH);
   if (com_port>-2 && bbs==OPUS)
      parse_ctl();         /* and jump to the right directory */

   if (com_port>=0 && use_fossil)
      init_fossil();

   dump(VERSION);
   dump("Archive File Viewer\n\n");
   if (dest_directory[0]==NULL) {
      dump("No work_directory specified\n");
      exit(1);
   }
   cd(dest_directory);  /* make sure destination directory exists */
   if (!findfirst("*.*",&ffblk,0)) {
      if (enforce_empty) {
         dump("Work directory is NOT empty, VIEW aborted\n");
         cd(cur_directory);
         exit(1);
      }
      else {
         system("echo Y | del *.* >NUL");
      }
   }

   cd(cur_directory);

   if (bbs>0 && com_port>-2) {
      dump("File Name (Wildcards Accepted):");
      get_string(string2,12);
      if (string2[0]==NULL)
         return;
      else
         strcpy(look_through,string2);

      if (!strstr(look_through,"."))
         strcat(look_through,".*");
   }

   if (bbs==RBBS)
      rbbs_search(look_through);

   if (!findfirst(look_through,&ffblk,0))
      list_files(look_through,0);
   else {
      dump("File not found\n");
      exit(1);
   }
   cd(cur_directory);
}
/***************************************************************************/
void list_files(char look_through[],int level)
{
   int done,fn,opt,i,j;
   char file_names[61][15];
   long size[61];

way_around:
   for (i=0;i<61;i++)
      file_names[i][0]=NULL;

   done=findfirst(look_through,&ffblk,0);
   if (done)
      exit(0);

   fn=1;
   while (!done) {
      strcpy(file_names[fn],ffblk.ff_name);
      size[fn++]=ffblk.ff_fsize;
      if (fn>60)  /* can't handle any more */
         break;
      done=findnext(&ffblk);
   }


around:

   if (level==0)
      cd(cur_directory);

   for (i=1;i<=20;i++) {
      for (j=0;j<3;j++) {
         if (file_names[i+j*20][0]!=NULL) {
            int k,pos1=0,pos2=0;
            char string[13];
            k=i+j*20;
            while (file_names[k][pos1]!='.' && file_names[k][pos1]!=NULL)
               string[pos2++]=file_names[k][pos1++];
            while (pos2<8)
               string[pos2++]=' ';
            string[pos2++]='.';
            if (file_names[k][pos1]=='.')
               pos1++;
            while (file_names[k][pos1]!=NULL)
               string[pos2++]=file_names[k][pos1++];
            while (pos2<12)
               string[pos2++]=' ';
            string[pos2]=NULL;

            {
               char string3[5];

               itoa(i+j*20,string3,10);
 
               if (strlen(string3)==1)
                  write_char(' ');
               dump(string3);
               dump(" - ");

               dump(string);
               dump("  ");
               itoa(size[i+j*20]/1024,string3,10);
               if (strlen(string3)<2)
                  write_char(' ');
               if (strlen(string3)<3)
                  write_char(' ');
               dump(string3);
               write_char('k');

               if (i+j*20 < 41 && file_names[i+j*20+20][0]!=NULL)
                  dump(" | ");
            }
         }
         else
            break;
      }
      if (file_names[i][0]==NULL)
         break;
      dump("\n");
   }

   dump("\nWhich file (0 to end):");
   get_string(string2,2);
   opt=atoi(string2);        /* string -> integer */
   if (opt<=0) {
      if (level>0) {
         system("echo Y | del *.* >NUL");
      }
      return;
   }
   else if (opt>fn-1)
      goto around;
   else {
      char option;
      if (downloads && com_port>=0) {
         dump("V)iew\n");
         dump("T)est archives integrity\n");
         dump("S)can for viruses\n");
         dump("C)onvert to different archive format\n");
         dump("Z)modem Download\n");
         dump("1)K Xmodem download\n");
         dump("X)modem Download\n\n");
         get_string(string2,1);
         option=toupper(string2,1);
      }
      else {
         option='V';
      }

      if (option=='V') {
         i=0;
         while (file_names[opt][i]!=NULL && file_names[opt][i]!='.')
            i++;
         j=0;
         while (file_names[opt][i]!=NULL)
            string2[j++]=file_names[opt][i++];
         string2[j]=NULL;
         strcat(string2,".");
         if (string2[0]==NULL || !strstr(avoid,string2)
            || is_self_extract(file_names[opt])) {
            strcpy(string2,"COPY ");
            strcat(string2,file_names[opt]);
            if (level==0) {
               strcat(string2," ");
               strcat(string2,dest_directory);
               strcat(string2," >NUL");
               system(string2);
               cd(dest_directory);
            }
            else {
               system("MD conv89");
               strcat(string2," conv89 >NUL");
               system(string2);
               system("cd conv89");
            }
            view(file_names[opt],level);
            goto around;
         }
         else {
            dump("Can't View this file, press return to continue");
            get_string(string2,1);
            goto around;
         }
      }
/*      else if (option=='T') {
         dump("Please wait, testing\n");
         dump("Files with .BAD extension are corrupt\n");
         system("TEST >NUL");
         goto way_around;
      }
      else if (option=='S') {
         dump("Please wait, scanning\n");
         dump("Files with .VIR extension are infected\n");
         system("ASCAN -a >NUL");
         goto way_around;
      }        */
      else if (option=='C') {
         dump("(L)harc\n");
         dump("(Z)ip\n");
         dump("(P)ak\n");
         dump("z(O)o\n");
         dump("(D)WC\n");
         dump("(A)rc\n");
         get_string(string2,1);
         option=toupper(string2,1);
         if (option=='L')
            system("convert -#1 -C online.cfg");
         else if (option=='Z')
            system("convert -#2 -C online.cfg");
         else if (option=='P')
            system("convert -#3 -C online.cfg");
         else if (option=='O')
            system("convert -#4 -C online.cfg");
         else if (option=='D')
            system("convert -#5 -C online.cfg");
         else if (option=='A')
            system("convert -#6 -C online.cfg");
         goto way_around;
      }
      else if (option=='Z') {
         char string3[2];
         strcpy(string2,"DSZ port ");
         string3[0]=com_port+49;
         string3[1]=NULL;
         strcat(string2,string3);
/*         strcat(string2," speed ");
         strcat(string2,baud_rate);  */

         strcat(string2," sz ");
         strcat(string2,file_names[opt]);
         system(string2);
         goto around;
      }
      else if (option=='1') {
         char string3[2];
         strcpy(string2,"DSZ port ");
         string3[0]=com_port+49;
         string3[1]=NULL;
         strcat(string2,string3);
/*         strcat(string2," speed ");
         strcat(string2,baud_rate);  */

         strcat(string2," sx -k ");
         strcat(string2,file_names[opt]);
         system(string2);
         goto around;
      }
      else if (option=='X') {
         char string3[2];
         strcpy(string2,"DSZ port ");
         string3[0]=com_port+49;
         string3[1]=NULL;
         strcat(string2,string3);
/*         strcat(string2," speed ");
         strcat(string2,baud_rate);  */

         strcat(string2," sx ");
         strcat(string2,file_names[opt]);
         system(string2);
         goto around;
      }
   }
}

/****************************************************************************/
void view(char string[],int level)
{
   FILE_N file;
   int c,done,line=0;

   if (unarc(string)) {
      list_files("*.*",level+1);
      if (level>0) {
         system("cd ..");
         system("rd conv89");
      }
      return;
   }

   if (com_port <0 && ext_lister[0]!=NULL) {
      strcpy(string2,ext_lister);
      strcat(string2," ");
      strcat(string2,string);
      system(string2);
   }
   else {

      file=my_fopen(string);

      while ((c=my_getc(file))!=EOF) {
         write_char(c);
         if (c=='\n') {
            line++;
            if (line>23) {
               dump("More?  [Y]es,[N]o,[C]ontinuous");
               c=read_char();
               if (!carrier)
                  break;
               write_char(13);
               dump("                                 ");
               write_char(13);
               if (c=='N' || c=='n')
                  break;
               else if (c=='C' || c=='c')
                  line=-31000;
               else
                  line=0;
            }
            if (use_fossil && com_port>=0) {
               union REGS regs;
               regs.h.ah = 0x03;
               regs.x.dx = com_port;
               regs.h.al = 0x00;
               int86(0x14, &regs, &regs);
               if (regs.h.ah & 1) {
                  get_com_char();
                  line=24;
               }
            }
            if (kbhit()) {
               my_getch();
               line=24;
            }
         }
      }
      my_fclose(file);
      dump("\n-----------End Of file ---------------");
      read_char();
      dump("\n");
   }
   if (level>0) {
      system("echo Y | del *.* >NUL");
      system("cd ..");
      system("rd conv89");
   }
   return;
}

/*********************************************************************/
char unarc(char string[])
{
   char string2[120];
   int i;
   long fsize;


   findfirst(string,&ffblk,0);
   fsize=ffblk.ff_fsize;
   strcpy(string2,"unarc -roff -yon");
   strcat(string2,string);
   if (self_extracts==1)
      strcat(string2," -xon");
   if (smart==1)
      strcat(string2," -son");
   strcat(string2," >NUL");
   system(string2);

   if (findfirst(string,&ffblk,0))
      return TRUE;
   else if (fsize!=ffblk.ff_fsize)
      return TRUE;
   else
      return FALSE;
}
/**************************************************/
/*       This function emulates the scanf         */
/**************************************************/
void get_string(string,max)   /* gets a string from the keyboard */
char string[];
int max;              /* maximum length of string */

{

   int c,i=0,smash=0;
   char temp_string[5];

   while (1) {
      if (!carrier)
         return;
      c=read_char();
      if (c==13 || c==27) {
         dump("\n");
         break;
      }

      if (c==3) {
         i=0;
         dump("\n");
         continue;
      }
      if (c==8 || c==075)    {            /* backspace pressed */
         if (i!=0) {
            write_char(8);
            write_char(32);
            write_char(8);
            i--;
         }
         continue;
      }
      else   {                            /* backed up too far */
         if (i<max) {
            string[i++]=(char)c;
            smash=0;
         }
         else {
            smash++;
            if (smash>20) {
               string[0]='0';
               string[1]=NULL;
               return;
            }
            write_char(BELL);
            continue;
         }
      }
      write_char(c);
   }
   string[i]=NULL;
   dump("\n");
   return;
}
/**********************************************************************/
void parse_ctl()
{
   char string2[FLENGTH],string[FLENGTH];
   FILE_N file;

   file=opencfg(ctl_file);

   while (TRUE) {
      get_file_line(file,string2);
      if (string2[0]==EOF)
         return;
      split_string(string2,string);
      if (stricmp(string,"KEYBOARD")==0)
         com_port=-1;
      else if (stricmp(string,"DOWNLOADS")==0) {
         strcpy(cur_directory,string2);
         cd(cur_directory);
      }
   }
}
/***************************************************************************/
/* COM port functions relating to the ol Fossil */
/***************************************************************************/
char get_com_char()  /* read a single character from the ol com port */
{
   union REGS regs;


   while (TRUE) {
      check_carrier();
      if (!carrier)
         return NULL;
      regs.h.ah=0x0C;
      regs.x.dx=com_port;
      int86(0x14,&regs,&regs);
      if (regs.x.ax==0xFFFF) {
         if (kbhit())                 /* look at the keyboard */
            return (my_getch());        /* return the character pressed */
         else
            continue;
      }
      else
         break;
   }

   regs.h.ah=0x02;         /* ok, there should be a character to get now */
   regs.x.dx=com_port;
   int86(0x14, &regs, &regs);
   return regs.h.al;
}
/**************************************************************************/
void put_com_char(char c)  /* write a single character to the ol com port */
{
   union REGS regs;


   regs.h.ah=0x01;
   regs.h.al=c;
   regs.x.dx=com_port;
   int86(0x14, &regs, &regs);

   while(TRUE)   {          /* Sit around while buffer empties */
      check_carrier();

      regs.h.ah = 0x03;
      regs.x.dx = com_port;
      regs.h.al = 0x00;
      int86(0x14, &regs, &regs);


      if (regs.x.ax == 0xffff) {
          /* ok, lets wipe the output buffer clean */
          regs.h.ah=0x09;
          regs.x.dx=com_port;
          int86(0x14, &regs, &regs);
          continue;
       }
       if (regs.h.ah & 1 || kbhit()) {         /* keystroke waiting */
          c=get_com_char();         /* stop */
          c=get_com_char();         /* restart */
       }
       if (regs.h.ah & 64)
          break;
   }
}
/*************************************************************************/
void init_fossil()
{
   union REGS regs;

   regs.h.ah=0x04;
   regs.x.dx=com_port;
   regs.h.al=0;
   regs.x.bx=0;
   int86(0x14, &regs, &regs);
   if (regs.x.ax!=0x1954) {
      dump("Error initializing Fossil!\n");
      exit(1);
   }
}
/*******************************************************************/
void check_carrier()
{
   union REGS regs;

   regs.h.ah = 0x03;
   regs.x.dx = com_port;
   regs.h.al = 0x00;
   int86(0x14, &regs, &regs);

   if (!(regs.x.ax & 0x80)) {
      carrier=FALSE;
      return;
   }
}
/****************************************************************************/
int read_char()
{
   if (com_port<0) {
      return my_getch();
   }
   else  {
      if (!use_fossil) {
         return bioscom(READ,0,com_port) & 255;
      }
      else
         return get_com_char();
   }
}
/***************************************************************************/
void write_char(char c)
{
   union REGS regs;

   if (c==10)
      write_char(13);

   regs.h.ah=2;           /* write to the screen */
   regs.h.dl=c;
   intdos(&regs,&regs);

   if (com_port>=0) {
      if (!use_fossil)
         bioscom(WRITE,c,com_port);
      else
         put_com_char(c);
   }
   return;
}
/***************************************************************************/
void rbbs_search(char look_through[])
{

   if (com_port<0 && !findfirst(look_through,&ffblk,0))
      return;

   temp_path=dpath_head;
   while (temp_path!=NULL) {
      cd(temp_path->dir);
      if (!findfirst(look_through,&ffblk,0))
         return;
      temp_path=temp_path->next;
   }
}
/*********************************************************/
/* Dumps a string to the serial port (or the screen)     */
void dump(char string[])
{
   int i=0;

   my_printf(string);
   if (com_port>=0) {
      while(string[i]!=NULL) {
         if (string[i]==10) {
            if (!use_fossil)
               bioscom(WRITE,13,com_port);
            else
               put_com_char(13);
         }
         if (!use_fossil)
            bioscom(WRITE,string[i++],com_port);
         else
            put_com_char(string[i++]);
      }
   }
}
/******************************************************************/
int fcount()                             /* count number of files */
{
   int done,counter=0;

   done=findfirst("*.*",&ffblk,0);
   while (!done) {
      counter++;
      done=findnext(&ffblk);
   }
   return counter;
}
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */

   int option,i;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)
            cur_argv = argv[++i];
         else
            cur_argv+=2;     /* advance it 2 characters */

         if (option=='S') {
            if (stricmp(cur_argv,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = (stricmp(cur_argv,"ON")==0);
         }
         else if (option=='X')
            self_extracts = stricmp(cur_argv,"ON")==0;
         else if (option=='C')
            strcpy(cfgfile,cur_argv);
         else if (option=='P')
            if (cur_argv[0]=='L')
               com_port=-3;
            else
               com_port=cur_argv[0]-48;
         else if(option=='B') {
            strcpy(baud_rate,cur_argv);
         }
         else if (option=='?') {
            dump("Command line parameters:\n-----------------------\n");
            dump("-son / -soff / -salways  Smart_mode on/off/always\n");
            dump("-xon / -xoff  self eXtracts on/off\n");
            dump("-c<file>      Alternate Configuration file\n");
            dump("-p<0-9, l>    Port number, L for local\n");
            exit (0);
         }
      }
      else
         strcpy(look_through,cur_argv);
   }
}

